<template>
  <div class="auth-page">
    <SelectLanguage class="select-language-component" />

    <div class="login-user">
      <div class="name-chat-component">
        <NameChat />
      </div>

      <Input
        :placeholder="$t('enterYourNickname')"
        :maxLength="20"
        @onChange="value => onChangeUser('nickname', value)"
        class="input-component"
      />

      <InputUploadFile
        @onChange="value => onChangeUser('avatar', value)"
      />

      <q-btn
        outline
        text-color="colorBorder"
        class="login-button"
        :disable="!isLoadingAvatar"
        @click.stop="onSubmit"
      >
        <span class="login-button__label">{{ $t('enter') }}</span>
      </q-btn>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from '@vue/composition-api'
import Input from 'components/Input.vue'
import InputUploadFile from 'components/InputUploadFile.vue'
import NameChat from 'components/NameChat.vue'
import SelectLanguage from 'components/SelectLanguage.vue'

export interface User {
  nickname: string;
  avatar: string;
}

export function IsUser (user: User): boolean {
  return !(user.nickname && user.avatar && user.nickname.length && user.avatar.length)
}

export default defineComponent({
  name: 'Auth',
  components: {
    Input,
    InputUploadFile,
    NameChat,
    SelectLanguage
  },

  setup (props, ctx) {
    const logo = {
      'ru-ru': 'statics/logo-ru.png',
      'en-us': 'statics/logo-en.png'
    }

    const user = reactive({}) as User
    const isLoadingAvatar = ref(false)

    function onSubmit (): void {
      ctx.root.$store.dispatch('main/user', user)
      ctx.root.$options.router.push('/chat')
    }

    function onChangeUser (type: string, value: string): void {
      if (type === 'nickname') {
        user.nickname = value
      } else user.avatar = value

      IsUser(user) && (isLoadingAvatar.value = true)
    }

    return {
      logo,
      user,
      isLoadingAvatar,
      onSubmit,
      onChangeUser
    }
  }
})
</script>

<style lang="scss" scoped>
@import '../../css/variables';

$indent: 1rem;

.auth-page {
  background-image: url(../../assets/junior-chat-background.png);
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-size: cover;
  width: 100vw;
  height: 100vh;
  display: flex;
  padding: 1rem;
}

.login-user {
  box-shadow: 0 0 5px 0 #ccc;
  max-width: 400px;
  flex-basis: 300px;
  position: relative;
  display: flex;
  flex-direction: column;
  background-color: #fff;
  background-clip: border-box;
  border: 1px solid rgba(20,20,31,.12);
  border-radius: .25rem;
  margin: auto;
  padding: $indent;
  overflow: hidden;

  &>*:not(:first-child) {
    margin-top: 14px;
  }
}
.name-chat-component {
  margin: auto;
}

.input-component {
  height: 48px;
}

.login-button {
  max-width: 150px;
}

.login-button__label {
  color: $textColor;
}

.select-language-component {
  margin-right: $indent;
  position: absolute;
  right: 0;
}
</style>
